/*
 * MZTalk - a small and simple talk program
 *
 * Copyright 2004 Marcello Zaniboni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package marcellozaniboni;

public class TalkKeyGen {
	protected static final String SUPPORTED_CHARACTERS =
		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 -_,.;:()[]#\\\"!|%&$/?'+*@";

	public String getNewKey() {
		// initialization
		java.util.Vector v = new java.util.Vector(SUPPORTED_CHARACTERS.length());
		for (int i = 0; i < SUPPORTED_CHARACTERS.length(); i++) v.add(new Character(SUPPORTED_CHARACTERS.charAt(i)));
		// calculation
		StringBuffer key = new StringBuffer();
		for (int i = 0; i < SUPPORTED_CHARACTERS.length(); i++) {
			int sorted = (int)Math.floor(Math.random() * v.size());
			Character sortedChar = (Character)(v.elementAt(sorted));
			key.append(sortedChar.charValue());
			v.remove(sorted);
		}
		return key.toString();
	}

	public static String encode(String msg, String key) {
		StringBuffer retVal = new StringBuffer();
		for (int i = 0; i < msg.length(); i++) {
			int p = SUPPORTED_CHARACTERS.indexOf(msg.charAt(i));
			retVal.append((p >=0) ? key.charAt(p) : msg.charAt(i));
		}
		return retVal.toString();
	}

	public static String decode(String msg, String key) {
		StringBuffer retVal = new StringBuffer();
		for (int i = 0; i < msg.length(); i++) {
			int p = key.indexOf(msg.charAt(i));
			retVal.append((p >=0) ? SUPPORTED_CHARACTERS.charAt(p) : msg.charAt(i));
		}
		return retVal.toString();
	}

}
