/*
 * MZTalk - a small and simple talk program
 *
 * Copyright 2004 Marcello Zaniboni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package marcellozaniboni;

import javax.swing.ImageIcon;
import javax.swing.UIManager;

public class TalkMain {


	public static void main(String[] args) {
		System.out.println("start");
		try {

			// GUI INIT
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch (javax.swing.UnsupportedLookAndFeelException ex1) {
				ex1.printStackTrace(System.err);
			} catch (ClassNotFoundException ex2) {
				ex2.printStackTrace(System.err);
			} catch (InstantiationException ex3) {
				ex3.printStackTrace(System.err);
			} catch (IllegalAccessException ex4) {
				ex4.printStackTrace(System.err);
			}

			final TalkUI ui = new TalkUI();
			final javax.swing.JFrame frame = new javax.swing.JFrame();
			javax.swing.SwingUtilities.updateComponentTreeUI(frame);

			frame.setContentPane(ui);
			frame.setSize(ui.getSize());
			frame.addWindowListener(
				new java.awt.event.WindowAdapter() {
					public void windowClosing(java.awt.event.WindowEvent e) {
						frame.hide();
						System.out.println("closing connection...");
						ui.closeConnection();
						System.out.println("end");
						System.exit(0);
					}
				});
			frame.setTitle(TalkManager.APP_TITLE);
			frame.setResizable(false);
			frame.setIconImage(new ImageIcon(
				(new TalkMain()).getClass().getResource(TalkManager.APP_ICON)).getImage());
			frame.show();
			java.awt.Insets insets = ui.getInsets();
			ui.setSize(400, 480);
			frame.setSize(ui.getWidth() + insets.left + insets.right, ui.getHeight() + insets.top + insets.bottom);
			ui.displayComponent(frame);
			frame.setVisible(true);

			// THREAD INIT
			TalkManager tm = new TalkManager(ui, ui.servermode, ui.remoteserver);
			tm.init();
		} catch (Throwable exception) {
			System.err.println("Exception occurred in main() of javax.swing.JFrame");
			exception.printStackTrace(System.out);
		}
	}
}
