/*
 * MZTalk - a small and simple talk program
 *
 * Copyright 2004 Marcello Zaniboni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package marcellozaniboni;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JViewport;

public class TalkUI extends javax.swing.JPanel implements ITalkUI {

    private JLabel messageLabel = null;
    private JTextField messageTextField = null;
    private JButton buttonSend = null;
    private JLabel talkLabel = null;
    private JScrollPane scroller = null;
    private JEditorPane talkText = null;
	private JButton buttonHelp = null;
	private JButton buttonLicense = null;
	private JButton buttonAbout = null;

    public boolean servermode = true;
    public String remoteserver = null;
    private static final String SEPARATOR = "- - - - - - - - - - - - - - - - -";
	private String messageToSend = null;

    private javax.swing.JLabel getMessageLabel() {
		if (messageLabel == null) {
			try {
				messageLabel = new javax.swing.JLabel();
				messageLabel.setBounds(10, 10, 370, 20);
				messageLabel.setName("MessageLabel");
				// messageLabel.setFont(new java.awt.Font("Arial", 0, 12));
				messageLabel.setOpaque(false);
				messageLabel.setText("Message:");
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return messageLabel;
	}

	private javax.swing.JTextField getMessageTextField() {
		if (messageTextField == null) {
			try {
				messageTextField = new javax.swing.JTextField();
				messageTextField.setBounds(10, 30, 370, 20);
				messageTextField.setName("MessageTextField");
				// messageTextField.setFont(new java.awt.Font("Arial", 0, 12));
				messageTextField.setOpaque(true);
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return messageTextField;
	}

	private javax.swing.JButton getButtonSend() {
		if (buttonSend == null) {
			try {
				buttonSend = new javax.swing.JButton();
                buttonSend.setText("Send");
                buttonSend.setBounds(10, 52, 370, 23);
				buttonSend.setName("ButtonSend");
				// buttonSend.setFont(new java.awt.Font("Arial", 0, 12));
				buttonSend.setOpaque(true);
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return buttonSend;
	}

    private javax.swing.JLabel getTalkLabel() {
		if (talkLabel == null) {
			try {
				talkLabel = new javax.swing.JLabel();
				talkLabel.setBounds(10, 80, 370, 20);
				talkLabel.setName("TalkLabel");
				// talkLabel.setFont(new java.awt.Font("Arial", 0, 12));
				talkLabel.setOpaque(false);
				talkLabel.setText("Conversation:");
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return talkLabel;
	}

    private javax.swing.JScrollPane getTalkScroller() {
        if (scroller == null) {
			try {
                scroller = new JScrollPane();
                scroller.setBounds(10, 100, 370, 310);
                talkText = new JEditorPane();
				// talkText.setBounds(10, 100, 320, 260); // experimental
                // talkText.setFont(new java.awt.Font("Arial", 0, 12));
                talkText.setEditable(false);
                JViewport vp = scroller.getViewport();
                vp.add(talkText);
				scroller.setName("TalkScroller");
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return scroller;
	}

	private javax.swing.JButton getButtonHelp() {
		if (buttonHelp == null) {
			try {
				buttonHelp = new javax.swing.JButton();
				buttonHelp.setText("Help");
				buttonHelp.setBounds(10, 420, 110, 23);
				buttonHelp.setName("ButtonHelp");
				// buttonHelp.setFont(new java.awt.Font("Arial", 0, 12));
				buttonHelp.setOpaque(true);
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return buttonHelp;
	}

	private javax.swing.JButton getButtonAbout() {
		if (buttonAbout == null) {
			try {
				buttonAbout = new javax.swing.JButton();
				buttonAbout.setText("About");
				buttonAbout.setBounds(140, 420, 110, 23);
				buttonAbout.setName("ButtonAbout");
				// buttonAbout.setFont(new java.awt.Font("Arial", 0, 12));
				buttonAbout.setOpaque(true);
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return buttonAbout;
	}

	private javax.swing.JButton getButtonLicense() {
		if (buttonLicense == null) {
			try {
				buttonLicense = new javax.swing.JButton();
				buttonLicense.setText("License");
				buttonLicense.setBounds(270, 420, 110, 23);
				buttonLicense.setName("ButtonLicanse");
				// buttonLicense.setFont(new java.awt.Font("Arial", 0, 12));
				buttonLicense.setOpaque(true);
			} catch (java.lang.Throwable t) {
				handleException(t);
			}
		}
		return buttonLicense;
	}

	class AddText implements ActionListener {
		public void actionPerformed(ActionEvent e) {
            addText(messageTextField.getText());
		}
	}

    private synchronized void addText(String text) {
        StringBuffer currentText = new StringBuffer(talkText.getText());
        if (!messageTextField.getText().trim().equals("")) {
			messageToSend = messageTextField.getText();
            if (!(talkText.getText().equals(""))) {
                currentText.append('\n');
                currentText.append(SEPARATOR);
                currentText.append('\n');
            }
            currentText.append(text);
            talkText.setText(currentText.toString());
            messageTextField.setText("");
        }
		messageTextField.grabFocus();
    }

	private void manageListeners() {
		buttonSend.addActionListener(new AddText());
		buttonHelp.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					new HelpDialog(TalkManager.APP_TITLE + " - Help",
						TalkManager.HELP_FILE,
						TalkManager.APP_ICON);
				}
			});
		buttonLicense.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					new HelpDialog(TalkManager.APP_TITLE + " - License",
						TalkManager.LICENSE_FILE,
						TalkManager.APP_ICON);
				}
			});
	}

    public TalkUI() {
        setName("MainPanel");
        setOpaque(true);
        setLayout(null);
        this.add(getMessageLabel(), getMessageLabel().getName());
        this.add(getMessageTextField(), getMessageTextField().getName());
        this.add(getButtonSend(), getButtonSend().getName());
        this.add(getTalkLabel(), getTalkLabel().getName());
        this.add(getTalkScroller(), getTalkScroller().getName());
        this.add(getButtonHelp(), getButtonHelp().getName());
		// this.add(getButtonAbout(), getButtonAbout().getName());
		this.add(getButtonLicense(), getButtonLicense().getName());
        this.manageListeners();
        String inputValue = JOptionPane.showInputDialog("Insert the server you want to connect to, or\ntype nothing if you want to run in server-mode.\n ");
        if (inputValue != null && (!inputValue.trim().equals(""))) {
            servermode = false;
            remoteserver = inputValue;
        } else {
            servermode = true;
            remoteserver = null;
        }
        this.setDisabled();
    }

	private void handleException(Throwable t) {
        t.printStackTrace(System.err);
    }

	public void displayComponent(java.awt.Component component) {
		int height = java.awt.Toolkit.getDefaultToolkit().getScreenSize().height;
		int width = java.awt.Toolkit.getDefaultToolkit().getScreenSize().width;
		int dialogHeight = component.getSize().height;
		int dialogWidth = component.getSize().width;
		component.setLocation(width / 2 - dialogWidth / 2, height / 2 - dialogHeight / 2);
		if (component instanceof javax.swing.JFrame) {
			//((javax.swing.JFrame)component).toFront();
			((javax.swing.JFrame) component).show();
		} else if (component instanceof javax.swing.JDialog) {
			//((javax.swing.JDialog)component).toFront();
			((javax.swing.JDialog) component).show();
		} else if (component instanceof javax.swing.JWindow) {
			//((javax.swing.JWindow)component).toFront();
			((javax.swing.JWindow) component).show();
		}
	}

    public boolean readyToSend() {
        return this.messageToSend != null;
    }

    public String getMessage() {
        String retVal = messageToSend;
        messageToSend = null;
        return retVal;
    }

    public void putMessage(String msg) {
		StringBuffer currentText = new StringBuffer(talkText.getText());
		if (!(talkText.getText().equals(""))) {
			currentText.append('\n');
			currentText.append(SEPARATOR);
			currentText.append('\n');
		}
		currentText.append(msg);
		talkText.setText(currentText.toString());
    }

	public void setEnabled() {
		messageTextField.setEnabled(true);
		buttonSend.setEnabled(true);
		talkText.setText("");
	}

	public void setDisabled() {
		messageTextField.setEnabled(false);
		buttonSend.setEnabled(false);
		talkText.setText("\n   Waiting for a client...");
	}

	public void closeConnection() {
		messageToSend = TalkManager.CLOSE_MESSAGE;
		try {
			Thread.sleep(TalkManager.SHUTDOWN_TIME);
		} catch (Throwable t) {
			t.printStackTrace(System.err);
		}
	}

	public void reportFatalError(String errorMessage) {
		JOptionPane.showMessageDialog(this,
			errorMessage,
			TalkManager.APP_TITLE + " - error", JOptionPane.WARNING_MESSAGE);
	}
}

